#!/bin/env python3


import sys
import re

ROOT_FILES = sys.argv[1:]
ROOT_CANDIDATES = []
for rf in ROOT_FILES:
    with open(rf) as f:
        r = f.read().strip()
        ROOT_CANDIDATES.append((rf, r))

ROOTS = []
for rf1, r1 in ROOT_CANDIDATES:
    accept = True
    for rf2, r2 in ROOT_CANDIDATES:
        if r1 == r2 and rf1 == rf2:
            continue
        if r1.startswith(r2 + '/'):
            sys.stderr.write('%s excluded since it is subsumed by %s\n' % (rf1, rf2))
            accept = False
    if accept:
        ROOTS.append(r1)

PATTERN = re.compile(r'\t(?:' + '|'.join(ROOTS) + r')[/\t]')
for line in sys.stdin:
    m = PATTERN.search(line)
    if m is not None:
        sys.stdout.write(line)
